=== cli_tools/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

if(LUA_FOUND)
  add_subdirectory("mympd-script")
endif()
