=== debian/changelog ===
mympd (16.0.1-1~mx23+1) mx; urgency=medium

  * New upstream release
  * Build for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Fri, 12 Jul 2024 03:26:43 +0000
