=== debian/control ===
Source: mympd
Section: sound
Priority: optional
Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
XSBC-Original-Maintainer: Juergen Mang <mail@jcgames.de>
Build-Depends: cmake,
               debhelper-compat (= 13),
               gzip,
               jq,
               libflac-dev,
               libid3tag0-dev,
               liblua5.4-dev,
               lua5.4,
               libpcre2-dev,
               libssl-dev,
               perl
Standards-Version: 4.1.2
Homepage: https://jcorporation.github.io/myMPD/

Package: mympd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: standalone, mobile friendly web-based MPD client.
 myMPD is a standalone and lightweight web-based MPD client. It's 
 tuned for minimal resource usage and requires very few dependencies.
 Therefore myMPD is ideal for Raspberry Pis and similar devices.
