=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure --  -DCMAKE_BUILD_TYPE=Release

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

%:
	dh $@
