## mympd 22.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # SPDX-License-Identifier: GPL-3.0-or-later
-# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
+# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
 # https://github.com/jcorporation/mympd
 
 # minimal cmake version needed for new option handling
@@ -9,9 +9,14 @@
 # myMPD is written in C
 # supported compilers: gcc, clang
 project(mympd
-  VERSION 16.0.1
+  VERSION 22.1.1
   LANGUAGES C
 )
+
+# Dependency versions
+set(LIBMPDCLIENT_MIN_VERSION "2.24.0")
+set(OPENSSL_MIN_VERSION "1.1.0")
+set(LUA_MIN_VERSION "5.3.0")
 
 # output binaries in bin directory
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
@@ -20,6 +25,7 @@
 message("Cmake src dir: ${PROJECT_SOURCE_DIR}")
 message("Cmake build dir: ${CMAKE_CURRENT_BINARY_DIR}")
 message("Cmake build type: ${CMAKE_BUILD_TYPE}")
+message("Cmake generator: ${CMAKE_GENERATOR}")
 message("Compiler: ${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}")
 message("CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
 message("CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS}")
@@ -42,18 +48,19 @@
 endif()
 
 # available options
-option(MYMPD_BUILD_TESTING "Enables building of unit tests" "OFF")
+option(MYMPD_BUILD_TESTING "Enables building of unit tests, default OFF" "OFF")
 option(MYMPD_DOC "Installs documentation, default ON" "ON")
 option(MYMPD_DOC_HTML "Creates and installs the html documentation, default OFF" "OFF")
 option(MYMPD_EMBEDDED_ASSETS "Embed assets in binary, default ON, OFF for Debug" "ON")
-option(MYMPD_ENABLE_EXPERIMENTAL "Enable experimental features" "OFF")
+option(MYMPD_EMBEDDED_LIBMPDCLIENT "Use embedded libmpdclient, default OFF" "OFF")
+option(MYMPD_ENABLE_EXPERIMENTAL "Enable experimental features, default OFF" "OFF")
 option(MYMPD_ENABLE_FLAC "Enables flac support, default ON" "ON")
 option(MYMPD_ENABLE_IPV6 "Enables IPv6, default ON" "ON")
 option(MYMPD_ENABLE_LIBID3TAG "Enables libid3tag support, default ON" "ON")
 option(MYMPD_ENABLE_LUA "Enables lua support, default ON" "ON")
 option(MYMPD_ENABLE_MYGPIOD "Enables myGPIOd support, default ON" "ON")
-option(MYMPD_MANPAGES "Creates and installs manpages" "ON")
-option(MYMPD_MINIMAL "Enables minimal myMPD build, disables all MYMPD_ENABLE_* flags" "OFF")
+option(MYMPD_MANPAGES "Creates and installs manpages, default ON" "ON")
+option(MYMPD_MINIMAL "Enables minimal myMPD build, disables all MYMPD_ENABLE_* flags, default OFF" "OFF")
 option(MYMPD_STARTUP_SCRIPT "Installs the startup script, default ON" "ON")
 # sanitizer options
 option(MYMPD_ENABLE_ASAN "Enables build with address sanitizer, default OFF" "OFF")
@@ -87,9 +94,35 @@
 find_library(MATH_LIB m REQUIRED)
 find_package(OpenSSL REQUIRED)
 
+if(MYMPD_EMBEDDED_LIBMPDCLIENT STREQUAL "ON")
+  message("Using embedded libmpdclient")
+else()
+  find_package(LIBMPDCLIENT)
+  if(LIBMPDCLIENT_FOUND)
+    if(LIBMPDCLIENT_VERSION VERSION_LESS "${LIBMPDCLIENT_MIN_VERSION}")
+      message(WARNING "libmpdclient ${LIBMPDCLIENT_VERSION} is too old, minimum version is ${LIBMPDCLIENT_MIN_VERSION}")
+      message("Using embedded libmpdclient")
+      set(MYMPD_EMBEDDED_LIBMPDCLIENT "ON")
+    else()
+      message("Using shared libmpdclient ${LIBMPDCLIENT_VERSION}")
+      set(MYMPD_EMBEDDED_LIBMPDCLIENT "OFF")
+    endif()
+  else()
+    message("libmpdclient not found, using embedded libmpdclient")
+    set(MYMPD_EMBEDDED_LIBMPDCLIENT "ON")
+  endif()
+endif()
+
+# set global libmpdclient mode
+if(MYMPD_EMBEDDED_LIBMPDCLIENT)
+  add_compile_options(
+    "-DMYMPD_EMBEDDED_LIBMPDCLIENT=1"
+  )
+endif()
+
 # check dependencies versions
-if(OPENSSL_VERSION VERSION_LESS "1.1.0")
-  message(FATAL_ERROR "myMPD requires an OpenSSL version greater or equal 1.1.0")
+if(OPENSSL_VERSION VERSION_LESS "${OPENSSL_MIN_VERSION}")
+  message(FATAL_ERROR "myMPD requires an OpenSSL version greater or equal ${OPENSSL_MIN_VERSION}")
 endif()
 
 # optional dependencies
@@ -97,7 +130,7 @@
   message("Searching for libid3tag")
   find_package(LIBID3TAG)
   if(NOT LIBID3TAG_FOUND)
-    message("Libid3tag is disabled because it was not found")
+    message(WARNING "Libid3tag is disabled because it was not found")
     set(MYMPD_ENABLE_LIBID3TAG "OFF")
   endif()
 else()
@@ -108,7 +141,7 @@
   message("Searching for flac")
   find_package(FLAC)
   if(NOT FLAC_FOUND)
-    message("Flac is disabled because it was not found")
+    message(WARNING "Flac is disabled because it was not found")
     set(MYMPD_ENABLE_FLAC "OFF")
   endif()
 else()
@@ -122,13 +155,13 @@
   message("Searching for lua")
   find_package(Lua)
   if(LUA_FOUND)
-    if(NOT LUA_VERSION_STRING VERSION_GREATER_EQUAL "5.3.0")
-      message("Lua is disabled because a version lower than 5.3.0 was found")
+    if(NOT LUA_VERSION_STRING VERSION_GREATER_EQUAL "${LUA_MIN_VERSION}")
+      message(WARNING "Lua is disabled because a version lower than ${LUA_MIN_VERSION} was found")
       set(MYMPD_ENABLE_LUA "OFF")
       set(MYMPD_ENABLE_MYGPIOD "OFF")
     endif()
   else()
-    message("Lua is disabled because it was not found")
+    message(WARNING "Lua is disabled because it was not found")
     set(MYMPD_ENABLE_LUA "OFF")
     set(MYMPD_ENABLE_MYGPIOD "OFF")
   endif()
@@ -184,7 +217,7 @@
   set(MYMPD_LUALIBS_PATH "")
   execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" createassets RESULT_VARIABLE RC_CREATE_ASSETS)
   # remove object files with embedded assets
-  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/web_server/utility.c.o")
+  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/webserver/mg_user_data.c.o")
   file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/mympd_api/scripts.c.o")
 else()
   message("Serving assets from filesystem")
@@ -262,6 +295,8 @@
 
 # configure some files - version and path information
 configure_file(src/compile_time.h.in "${PROJECT_BINARY_DIR}/compile_time.h")
+configure_file(src/webserver/embedded_files.c.in "${PROJECT_BINARY_DIR}/embedded_files.c")
+configure_file(src/scripts/lualibs.c.in "${PROJECT_BINARY_DIR}/lualibs.c")
 configure_file(cmake/Install.cmake.in cmake/Install.cmake @ONLY)
 configure_file(contrib/initscripts/mympd.service.system.in contrib/initscripts/system/mympd.service @ONLY)
 configure_file(contrib/initscripts/mympd.service.user.in contrib/initscripts/user/mympd.service @ONLY)
@@ -272,7 +307,9 @@
 # global compile options
 add_compile_options(
   "-DMPACK_HAS_CONFIG=1"
+  "-DMG_MAX_HTTP_HEADERS=50"
 )
+
 # set myMPD specific debug define
 if(CMAKE_BUILD_TYPE STREQUAL "Debug")
   add_compile_options(
@@ -281,17 +318,32 @@
 endif()
 
 if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
-  # set strict global compile flags
-  add_compile_options(
+  set(C_OPTS
+    "-D_GLIBCXX_ASSERTIONS"
+    "-D_LIBCXX_ENABLE_ASSERTIONS"
+    "-fcf-protection=full"
     "-fdata-sections"
     "-ffunction-sections"
+    "-fno-delete-null-pointer-checks"
+    "-fno-omit-frame-pointer"
+    "-fno-plt"
+    "-fno-strict-aliasing"
+    "-fno-strict-overflow"
+    "-fstack-clash-protection"
     "-fstack-protector-strong"
+    "-fstrict-flex-arrays=3"
+    "-ftrivial-auto-var-init=zero"
+    "-mbranch-protection=standard"
+    "-mno-omit-leaf-frame-pointer"
+    "-mshstk"
     "-pedantic"
+    "-std=gnu17"
     "-Wall"
     "-Werror"
     "-Wextra"
-    "-Wformat"
+    "-Wformat=2"
     "-Wformat-security"
+    "-Wformat-nonliteral"
     "-Winit-self"
     "-Wmissing-include-dirs"
     "-Wnested-externs"
@@ -299,80 +351,3 @@
     "-Wredundant-decls"
     "-Wshadow"
     "-Wsign-compare"
-    "-Wstrict-prototypes"
-    "-Wundef"
-    "-Wuninitialized"
-    "-Wunused-parameter"
-    "-Wvla"
-    "-Wwrite-strings"
-  )
-
-  # check for supported compiler flags
-  foreach(FLAG IN ITEMS "-std=gnu17" "-fstack-clash-protection" "-fcf-protection" "-fno-plt")
-    message("Checking for compiler flag ${FLAG}")
-    unset(COMPILER_SUPPORTS_FLAG CACHE)
-    unset(COMPILER_SUPPORTS_FLAG)
-    check_c_compiler_flag("${FLAG}" COMPILER_SUPPORTS_FLAG)
-    if(COMPILER_SUPPORTS_FLAG)
-      add_compile_options("${FLAG}")
-    endif()
-  endforeach()
-
-  if(NOT MYMPD_ENABLE_ASAN AND NOT MYMPD_ENABLE_UBSAN)
-    # incompatible with address sanitizers
-    if(NOT CMAKE_C_FLAGS MATCHES "_FORTIFY_SOURCE")
-      add_compile_options("-D_FORTIFY_SOURCE=2")
-    endif()
-  endif()
-else()
-  # if CMAKE_BUILD_TYPE is neither Release nor Debug,
-  # do not alter compile options
-endif()
-
-# sanitizers
-set(ASAN_FLAGS
-  "-fsanitize=address"
-  "-fsanitize=leak"
-)
-
-set(UBSAN_FLAGS
-  "-fsanitize=undefined"
-)
-
-set(TSAN_FLAGS
-  "-fsanitize=thread"
-)
-
-if(MYMPD_ENABLE_ASAN)
-  message("Compiling with address sanitizer")
-  add_compile_options(
-    ${ASAN_FLAGS}
-    "-fno-omit-frame-pointer"
-  )
-elseif(MYMPD_ENABLE_UBSAN)
-  message("Compiling with undefined behavior sanitizer")
-  add_compile_options(
-    ${UBSAN_FLAGS}
-    "-fno-omit-frame-pointer"
-  )
-elseif(MYMPD_ENABLE_TSAN)
-  message("Compiling with thread sanitizer")
-  add_compile_options(
-    ${TSAN_FLAGS}
-    "-fno-omit-frame-pointer"
-  )
-endif()
-
-if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-  add_compile_options(
-    "-ggdb"
-    "-Og"
-  )
-  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
-elseif(CMAKE_BUILD_TYPE MATCHES "(Release|RelWithDebInfo|MinSizeRel)")
-  add_compile_options(
-    "-fPIE"
-    "-O2"
-  )
-  if(CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
-    message("Generating binary with debug symbols")
