=== debian/changelog ===
mympd (22.1.1-1) unstable; urgency=medium

  * Release from master

 -- Juergen Mang <mail@jcgames.de>  Sat, 11 Oct 2025 12:10:13 +0200
